; 

 .data

	dwNodeCount		dd ?

	lpString1		dd ?
	lpString2		dd ?

	lpNodeInfoStart		dd ?
	lpNodeInfo		dd ?
	lpParentNodeInfo	dd ?

	szNodeFormat		db 0Dh,0Ah,'Node',0Dh,0Ah,' name:   %s',0Dh,0Ah,' id:     %ld',0Dh,0Ah,' parent: %s',0Dh,0Ah
				db ' links:  %ld',0Dh,0Ah,0
	szAtomFormat		db 0Dh,0Ah,'Atom',0Dh,0Ah,' name:   %s',0Dh,0Ah,' id:     %ld',0Dh,0Ah,' parent: %s',0Dh,0Ah
				db ' stores: %s',0Dh,0Ah,0

; 

 .code

; 

MyStartTagHandler	PROC USES ebx esi edi lpTag:DWORD,lpAttributeList:DWORD

			mov	eax,lpParentNodeInfo
			mov	edi,lpNodeInfo				; get free space for next nodeinfo
; PrintHex edi,'node start'
			add	dwNodeCount,1				; global node count
			push	dwNodeCount
			pop	(NODE_INFO PTR [edi]).id		; set global id

			cmp	eax,edi
			jz @F
				add	(NODE_INFO PTR [eax]).links,1	; increase the number of links
@@:
			lea	ebx,(NODE_INFO PTR [edi])._name		; copy tag name into nodeinfo
			invoke WideCharToMultiByte,CP_ACP,WC_COMPOSITECHECK,lpTag,-1,ebx,sizeof NODE_INFO._name,NULL,NULL
; PrintStringByAddr ebx
			mov	(NODE_INFO PTR [edi]).links,0		; set links initialy to zero
			mov	(NODE_INFO PTR [edi]).value,NULL	; stored value is blank

			mov	eax,lpParentNodeInfo
			mov	(NODE_INFO PTR [edi]).lpParent,eax	; set parent nodeinfo
			mov	lpParentNodeInfo,edi			; set new parent
			add	edi,sizeof NODE_INFO

			mov	esi,lpAttributeList
			or	esi,esi
			jz @F
		; process attribute list
@1:
			mov	eax,[esi]				; get attribute name
			or	eax,eax
			jz @F
; PrintHex edi,'node att'
			lea	ebx,(NODE_INFO PTR [edi])._name		; set attribute name
			invoke WideCharToMultiByte,CP_ACP,WC_COMPOSITECHECK,eax,-1,ebx,sizeof NODE_INFO._name,NULL,NULL
			mov	eax,[esi+4]
			lea	ebx,(NODE_INFO PTR [edi]).value		; set attribute value
			invoke WideCharToMultiByte,CP_ACP,WC_COMPOSITECHECK,eax,-1,ebx,sizeof NODE_INFO.value,NULL,NULL
			add	dwNodeCount,1
			mov	eax,dwNodeCount
			mov	(NODE_INFO PTR [edi]).links,0		; set links to zero
			neg	eax
			mov	(NODE_INFO PTR [edi]).id,eax
			mov	eax,lpParentNodeInfo
			add	(NODE_INFO PTR [eax]).links,1		; increase the number of links
			mov	(NODE_INFO PTR [edi]).lpParent,eax	; set parent
			add	edi,sizeof NODE_INFO			; next nodeinfo
			add	esi,8					; next attribute
			jmp @1
@@:
			mov	lpNodeInfo,edi				; store pointer of free space
; PrintHex edi,'node end'

			mov	eax,1
			ret
MyStartTagHandler	ENDP

; 

MyCDATAHandler		PROC USES edi lpCDATA:DWORD

			mov	edi,lpNodeInfo
			sub	edi,sizeof NODE_INFO
; PrintHex edi,'node cdata'
 			lea	eax,(NODE_INFO PTR [edi]).value		; set atom's value
			invoke WideCharToMultiByte,CP_ACP,WC_COMPOSITECHECK,lpCDATA,-1,eax,sizeof NODE_INFO.value,NULL,NULL
			mov	eax,dwNodeCount
			neg	eax
			mov	(NODE_INFO PTR [edi]).id,eax		; set atom id

			mov	eax,1
			ret
MyCDATAHandler		ENDP

; 

MyEndTagHandler		PROC USES edi lpTag:DWORD

			mov	edi,lpParentNodeInfo
			mov	eax,(NODE_INFO PTR [edi]).lpParent	; get back last parent
			mov	lpParentNodeInfo,eax
; PrintHex eax,'node close'
			mov	eax,1
			ret
MyEndTagHandler		ENDP

; 
